Index: frontends/php/include/events.inc.php
===================================================================
--- frontends/php/include/events.inc.php	(revision 38884)
+++ frontends/php/include/events.inc.php	(working copy)
@@ -28,14 +28,14 @@
 	}
 
 	function get_event_by_eventid($eventid){
-		$db_events = DBselect('select * from events where eventid='.$eventid);
+		$db_events = DBselect('select * from events where eventid='.zbx_dbstr($eventid));
 		return DBfetch($db_events);
 	}
 
 	function get_tr_event_by_eventid($eventid){
 		$result = DBfetch(DBselect('SELECT e.*,t.triggerid, t.description,t.priority,t.status,t.type '.
 									' FROM events e,triggers t '.
-									' WHERE e.eventid='.$eventid.
+									' WHERE e.eventid='.zbx_dbstr($eventid).
 										' AND e.object='.EVENT_OBJECT_TRIGGER.
 										' AND t.triggerid=e.objectid '
 									));
@@ -86,7 +86,7 @@
 	if(empty($events)){
 		$sql = 'SELECT e.eventid '.
 				' FROM events e '.
-				' WHERE e.objectid='.$row['triggerid'].$sql_cond.
+				' WHERE e.objectid='.zbx_dbstr($row['triggerid']).$sql_cond.
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' ORDER BY e.object, e.objectid, e.eventid';
 		$res = DBselect($sql,1);
@@ -97,8 +97,8 @@
 		$eventid = $events[0]['eventid'];
 		$sql = 'SELECT e.eventid '.
 				' FROM events e '.
-				' WHERE e.eventid > '.$eventid.
-					' AND e.objectid='.$row['triggerid'].$sql_cond.
+				' WHERE e.eventid > '.zbx_dbstr($eventid).
+					' AND e.objectid='.zbx_dbstr($row['triggerid']).$sql_cond.
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' ORDER BY e.object, e.objectid, e.eventid';
 		$res = DBselect($sql,1);
@@ -117,10 +117,10 @@
 
 		$sql = 'SELECT e.eventid,e.clock '.
 				' FROM events e '.
-				' WHERE e.eventid > '.$eventid.
-					' AND e.objectid='.$row['triggerid'].
+				' WHERE e.eventid > '.zbx_dbstr($eventid).
+					' AND e.objectid='.zbx_dbstr($row['triggerid']).
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
-					' AND e.value='.$row['value'].
+					' AND e.value='.zbx_dbstr($row['value']).
 				' ORDER BY e.object, e.objectid, e.eventid';
 		$res = DBselect($sql,1);
 		$rows = DBfetch($res);
@@ -151,8 +151,8 @@
 
 	$sql = 'SELECT e.eventid, e.value '.
 			' FROM events e '.
-			' WHERE e.objectid='.$row['triggerid'].
-				' AND e.eventid < '.$row['eventid'].
+			' WHERE e.objectid='.zbx_dbstr($row['triggerid']).
+				' AND e.eventid < '.zbx_dbstr($row['eventid']).
 				' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' AND e.value='.TRIGGER_VALUE_FALSE.
 			' ORDER BY e.object DESC, e.objectid DESC, e.eventid DESC';
@@ -160,8 +160,8 @@
 
 	$sql = 'SELECT e.eventid, e.value '.
 			' FROM events e'.
-			' WHERE e.objectid='.$row['triggerid'].
-				' AND e.eventid < '.$row['eventid'].
+			' WHERE e.objectid='.zbx_dbstr($row['triggerid']).
+				' AND e.eventid < '.zbx_dbstr($row['eventid']).
 				' AND e.object='.EVENT_OBJECT_TRIGGER.
 				' AND e.value='.TRIGGER_VALUE_TRUE.
 			' ORDER BY e.object DESC, e.objectid DESC, e.eventid DESC';
@@ -171,8 +171,8 @@
 	if($hide_unknown == 0){
 		$sql = 'SELECT e.eventid, e.value '.
 				' FROM events e'.
-				' WHERE e.objectid='.$row['triggerid'].
-					' AND e.eventid < '.$row['eventid'].
+				' WHERE e.objectid='.zbx_dbstr($row['triggerid']).
+					' AND e.eventid < '.zbx_dbstr($row['eventid']).
 					' AND e.object='.EVENT_OBJECT_TRIGGER.
 					' AND e.value='.TRIGGER_VALUE_UNKNOWN.
 				' ORDER BY e.object DESC, e.objectid DESC, e.eventid DESC';
@@ -202,19 +202,19 @@
 	if((TRIGGER_MULT_EVENT_ENABLED == $row['type']) && (TRIGGER_VALUE_TRUE == $row['value'])){
 		$sql = 'SELECT e.eventid, e.value, e.clock '.
 			' FROM events e'.
-			' WHERE e.objectid='.$row['objectid'].
-				' AND e.eventid > '.$row['eventid'].
+			' WHERE e.objectid='.zbx_dbstr($row['objectid']).
+				' AND e.eventid > '.zbx_dbstr($row['eventid']).
 				' AND e.object='.EVENT_OBJECT_TRIGGER.
-				' AND e.value='.$row['value'].
+				' AND e.value='.zbx_dbstr($row['value']).
 			' ORDER BY e.object, e.objectid, e.eventid';
 	}
 	else{
 		$sql = 'SELECT e.eventid, e.value, e.clock '.
 			' FROM events e'.
-			' WHERE e.objectid='.$row['objectid'].
-				' AND e.eventid > '.$row['eventid'].
+			' WHERE e.objectid='.zbx_dbstr($row['objectid']).
+				' AND e.eventid > '.zbx_dbstr($row['eventid']).
 				' AND e.object='.EVENT_OBJECT_TRIGGER.
-				' AND e.value<>'.$row['value'].
+				' AND e.value<>'.zbx_dbstr($row['value']).
 				$sql_cond.
 			' ORDER BY e.object, e.objectid, e.eventid';
 	}
@@ -337,9 +337,9 @@
 	$event_list = array();
 	$sql = 'SELECT * '.
 			' FROM events '.
-			' WHERE eventid<='.$eventid.
+			' WHERE eventid<='.zbx_dbstr($eventid).
 				' AND object='.EVENT_OBJECT_TRIGGER.
-				' AND objectid='.$triggerid.
+				' AND objectid='.zbx_dbstr($triggerid).
 			' ORDER BY eventid DESC';
 	$db_events = DBselect($sql, ZBX_POPUP_MAX_ROWS);
 
@@ -396,11 +396,11 @@
 	$available_triggers = get_accessible_triggers(PERM_READ_ONLY, array(), PERM_RES_DATA_ARRAY, get_current_nodeid());
 
 	if($hostid > 0){
-		$sql_cond = ' AND h.hostid='.$hostid;
+		$sql_cond = ' AND h.hostid='.zbx_dbstr($hostid);
 	}
 	else if($groupid > 0){
 		$sql_from = ', hosts_groups hg ';
-		$sql_cond = ' AND h.hostid=hg.hostid AND hg.groupid='.$groupid;
+		$sql_cond = ' AND h.hostid=hg.hostid AND hg.groupid='.zbx_dbstr($groupid);
 	}
 	else{
 		$sql_from = '';
Index: frontends/php/include/images.inc.php
===================================================================
--- frontends/php/include/images.inc.php	(revision 38884)
+++ frontends/php/include/images.inc.php	(working copy)
@@ -42,7 +42,7 @@
 
 	function get_image_by_imageid($imageid){
 
-		$sql = 'SELECT * FROM images WHERE imageid='.$imageid;
+		$sql = 'SELECT * FROM images WHERE imageid='.zbx_dbstr($imageid);
 		$result = DBselect($sql);
 		if($row = DBfetch($result)){
 			$row['image'] = zbx_unescape_image($row['image']);
@@ -80,7 +80,7 @@
 				if($DB['TYPE'] == 'POSTGRESQL'){
 					$image = pg_escape_bytea($image);
 					$sql = 'INSERT INTO images (imageid, name, imagetype, image) '.
-									' VALUES ('.$imageid.','.zbx_dbstr($name).','.$imagetype.",'".$image."')";
+									' VALUES ('.$imageid.','.zbx_dbstr($name).','.zbx_dbstr($imagetype).",'".$image."')";
 					return	DBexecute($sql);
 				}
 				else if($DB['TYPE'] == 'ORACLE'){
@@ -88,7 +88,7 @@
 					$lobimage = OCINewDescriptor($DB['DB'], OCI_D_LOB);
 
 					$stid = OCIParse($DB['DB'], 'insert into images (imageid,name,imagetype,image)'.
-						" values ($imageid,".zbx_dbstr($name).','.$imagetype.",EMPTY_BLOB())".
+						" values ($imageid,".zbx_dbstr($name).','.zbx_dbstr($imagetype).",EMPTY_BLOB())".
 						' return image into :image');
 					if(!$stid){
 						$e = ocierror($stid);
@@ -120,7 +120,7 @@
 				}
 
 				return	DBexecute('INSERT INTO images (imageid, name, imagetype, image) '.
-									' VALUES ('.$imageid.','.zbx_dbstr($name).','.$imagetype.','.zbx_dbstr($image).')');
+									' VALUES ('.$imageid.','.zbx_dbstr($name).','.zbx_dbstr($imagetype).','.zbx_dbstr($image).')');
 			}
 			else{
 				error(S_IMAGE_SIZE_MUST_BE_LESS_THAN_MB);
@@ -137,7 +137,7 @@
 // only update parameters
 			return	DBexecute('UPDATE images '.
 							' SET name='.zbx_dbstr($name).',imagetype='.zbx_dbstr($imagetype).
-							' WHERE imageid='.$imageid);
+							' WHERE imageid='.zbx_dbstr($imageid));
 		}
 		else{
 			global $DB;
@@ -153,12 +153,12 @@
 				if($DB['TYPE'] == 'ORACLE'){
 					$result = DBexecute('UPDATE images '.
 									' SET name='.zbx_dbstr($name).',imagetype='.zbx_dbstr($imagetype).
-									' WHERE imageid='.$imageid);
+									' WHERE imageid='.zbx_dbstr($imageid));
 
 					if(!$result) return $result;
 
 
-					if(!$stid = DBselect('SELECT image FROM images WHERE imageid='.$imageid.' FOR UPDATE')){
+					if(!$stid = DBselect('SELECT image FROM images WHERE imageid='.zbx_dbstr($imageid).' FOR UPDATE')){
 					return false;
 					}
 
@@ -174,7 +174,7 @@
 					$image = pg_escape_bytea($image);
 					$sql='UPDATE images '.
 						' SET name='.zbx_dbstr($name).',imagetype='.zbx_dbstr($imagetype).",image='".$image."'".
-						' WHERE imageid='.$imageid;
+						' WHERE imageid='.zbx_dbstr($imageid);
 				return	DBexecute($sql);
 				}
 				else if($DB['TYPE'] == 'SQLITE3'){
@@ -182,7 +182,7 @@
 				}
 
 				$sql='UPDATE images SET name='.zbx_dbstr($name).',imagetype='.zbx_dbstr($imagetype).',image='.zbx_dbstr($image).
-					' WHERE imageid='.$imageid;
+					' WHERE imageid='.zbx_dbstr($imageid);
 
 				return	DBexecute($sql);
 			}
@@ -195,7 +195,7 @@
 
 	function delete_image($imageid){
 		if(!checkImagesToDelete($imageid)) return false;
-		$result = DBexecute('DELETE FROM images WHERE imageid='.$imageid);
+		$result = DBexecute('DELETE FROM images WHERE imageid='.zbx_dbstr($imageid));
 
 	return $result;
 	}
Index: frontends/php/include/maintenances.inc.php
===================================================================
--- frontends/php/include/maintenances.inc.php	(revision 38884)
+++ frontends/php/include/maintenances.inc.php	(working copy)
@@ -40,7 +40,7 @@
 	$sql =	'SELECT DISTINCT m.maintenanceid '.
 			' FROM maintenances m, maintenances_hosts mh, maintenances_groups mg, hosts_groups hg '.
 			' WHERE '.DBcondition('hg.hostid',$available_hosts,true).
-				(!empty($hostid)?' AND hg.hostid='.$hostid:'').
+				(!empty($hostid)?' AND hg.hostid='.zbx_dbstr($hostid):'').
 				' AND ('.
 					'(mh.hostid=hg.hostid AND m.maintenanceid=mh.maintenanceid)'.
 					' OR (mg.groupid=hg.groupid AND m.maintenanceid=mg.maintenanceid))';
@@ -78,7 +78,7 @@
 	$sql = 'SELECT m.* '.
 			' FROM maintenances m '.
 			' WHERE '.DBin_node('m.maintenanceid').
-				' AND maintenanceid='.$maintenanceid;
+				' AND maintenanceid='.zbx_dbstr($maintenanceid);
 
 	$maintenance = DBfetch(DBselect($sql));
 return $maintenance;
@@ -104,10 +104,10 @@
 	$result = DBexecute('INSERT INTO maintenances (maintenanceid,name,maintenance_type,description,active_since,active_till) '.
 				' VALUES ('.$maintenanceid.','.
 						zbx_dbstr($maintenance['name']).','.
-						$maintenance['maintenance_type'].','.
+						zbx_dbstr($maintenance['maintenance_type']).','.
 						zbx_dbstr($maintenance['description']).','.
-						$maintenance['active_since'].','.
-						$maintenance['active_till'].')');
+						zbx_dbstr($maintenance['active_since']).','.
+						zbx_dbstr($maintenance['active_till']).')');
 
 return $result?$maintenanceid:false;
 }
@@ -115,7 +115,7 @@
 // function: update_maintenance
 // author: Aly
 function update_maintenance($maintenanceid, $maintenance = array()){
-	$sql = 'SELECT * FROM maintenances WHERE maintenanceid='.$maintenanceid;
+	$sql = 'SELECT * FROM maintenances WHERE maintenanceid='.zbx_dbstr($maintenanceid);
 	if(!$db_maintenance = DBfetch(DBselect($sql))){
 		return false;
 	}
@@ -127,11 +127,11 @@
 
 	$sql = 'UPDATE maintenances SET '.
 				' name='.zbx_dbstr($maintenance['name']).','.
-				' maintenance_type='.$maintenance['maintenance_type'].','.
+				' maintenance_type='.zbx_dbstr($maintenance['maintenance_type']).','.
 				' description='.zbx_dbstr($maintenance['description']).','.
-				' active_since='.$maintenance['active_since'].','.
-				' active_till='.$maintenance['active_till'].
-			' WHERE maintenanceid='.$maintenanceid;
+				' active_since='.zbx_dbstr($maintenance['active_since']).','.
+				' active_till='.zbx_dbstr($maintenance['active_till']).
+			' WHERE maintenanceid='.zbx_dbstr($maintenanceid);
 	$result = DBexecute($sql);
 
 return $result;
@@ -154,13 +154,13 @@
 function save_maintenance_host_links($maintenanceid, $hostids){
 	$result = true;
 
-	DBexecute('DELETE FROM maintenances_hosts WHERE maintenanceid='.$maintenanceid);
+	DBexecute('DELETE FROM maintenances_hosts WHERE maintenanceid='.zbx_dbstr($maintenanceid));
 	foreach($hostids as $id => $hostid)
 	{
 		$maintenance_hostid = get_dbid('maintenances_hosts','maintenance_hostid');
 
 		$result = DBexecute('INSERT INTO maintenances_hosts (maintenance_hostid,maintenanceid,hostid)'.
-				' VALUES ('.$maintenance_hostid.','.$maintenanceid.','.$hostid.')');
+				' VALUES ('.$maintenance_hostid.','.zbx_dbstr($maintenanceid).','.zbx_dbstr($hostid).')');
 	}
 
 return $result;
@@ -169,13 +169,13 @@
 function save_maintenance_group_links($maintenanceid, $groupids){
 	$result = true;
 
-	DBexecute('DELETE FROM maintenances_groups WHERE maintenanceid='.$maintenanceid);
+	DBexecute('DELETE FROM maintenances_groups WHERE maintenanceid='.zbx_dbstr($maintenanceid));
 	foreach($groupids as $id => $groupid)
 	{
 		$maintenance_groupid = get_dbid('maintenances_groups','maintenance_groupid');
 
 		$result = DBexecute('INSERT INTO maintenances_groups (maintenance_groupid,maintenanceid,groupid)'.
-				' VALUES ('.$maintenance_groupid.','.$maintenanceid.','.$groupid.')');
+				' VALUES ('.$maintenance_groupid.','.zbx_dbstr($maintenanceid).','.zbx_dbstr($groupid).')');
 	}
 
 return $result;
@@ -203,14 +203,14 @@
 
 	$result = DBexecute('INSERT INTO timeperiods (timeperiodid,timeperiod_type,every,month,dayofweek,day,start_time,period,start_date) '.
 				' VALUES ('.$timeperiodid.','.
-						$timeperiod['timeperiod_type'].','.
-						$timeperiod['every'].','.
-						$timeperiod['month'].','.
-						$timeperiod['dayofweek'].','.
-						$timeperiod['day'].','.
-						$timeperiod['start_time'].','.
-						$timeperiod['period'].','.
-						$timeperiod['start_date'].')');
+					zbx_dbstr($timeperiod['timeperiod_type']).','.
+					zbx_dbstr($timeperiod['every']).','.
+					zbx_dbstr($timeperiod['month']).','.
+					zbx_dbstr($timeperiod['dayofweek']).','.
+					zbx_dbstr($timeperiod['day']).','.
+					zbx_dbstr($timeperiod['start_time']).','.
+					zbx_dbstr($timeperiod['period']).','.
+					zbx_dbstr($timeperiod['start_date']).')');
 
 return $result?$timeperiodid:false;
 }
@@ -254,12 +254,12 @@
 	zbx_value2array($timeperiodids);
 	$result = true;
 
-	DBexecute('DELETE FROM maintenances_windows WHERE maintenanceid='.$maintenanceid);
+	DBexecute('DELETE FROM maintenances_windows WHERE maintenanceid='.zbx_dbstr($maintenanceid));
 
 	foreach($timeperiodids as $id => $timeperiodid){
 		$maintenance_timeperiodid = get_dbid('maintenances_windows', 'maintenance_timeperiodid');
 		$sql = 'INSERT INTO maintenances_windows (maintenance_timeperiodid,timeperiodid,maintenanceid) '.
-				' VALUES ('.$maintenance_timeperiodid.','.$timeperiodid.','.$maintenanceid.')';
+				' VALUES ('.$maintenance_timeperiodid.','.zbx_dbstr($timeperiodid).','.zbx_dbstr($maintenanceid).')';
 		$result = DBexecute($sql);
 	}
 return $result;
Index: frontends/php/include/media.inc.php
===================================================================
--- frontends/php/include/media.inc.php	(revision 38884)
+++ frontends/php/include/media.inc.php	(working copy)
@@ -53,7 +53,7 @@
 
 	function get_media_by_mediaid($mediaid){
 
-		$sql="select * from media where mediaid=$mediaid";
+		$sql="select * from media where mediaid=".zbx_dbstr($mediaid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row)
@@ -69,18 +69,18 @@
 
 // Delete Media definition by mediatypeid
 	function delete_media_by_mediatypeid($mediatypeid){
-		$sql="delete from media where mediatypeid=$mediatypeid";
+		$sql="delete from media where mediatypeid=".zbx_dbstr($mediatypeid);
 		return	DBexecute($sql);
 	}
 
 // Delete alerts by mediatypeid
 	function delete_alerts_by_mediatypeid($mediatypeid){
-		$sql="delete from alerts where mediatypeid=$mediatypeid";
+		$sql="delete from alerts where mediatypeid=".zbx_dbstr($mediatypeid);
 		return	DBexecute($sql);
 	}
 
 	function get_mediatype_by_mediatypeid($mediatypeid){
-		$sql="select * from media_type where mediatypeid=$mediatypeid";
+		$sql="select * from media_type where mediatypeid=".zbx_dbstr($mediatypeid);
 		$result=DBselect($sql);
 		$row=DBfetch($result);
 		if($row){
@@ -98,7 +98,7 @@
 		delete_alerts_by_mediatypeid($mediatypeid);
 		$mediatype = get_mediatype_by_mediatypeid($mediatypeid);
 
-		$sql='DELETE FROM media_type WHERE mediatypeid='.$mediatypeid;
+		$sql='DELETE FROM media_type WHERE mediatypeid='.zbx_dbstr($mediatypeid);
 
 		if($ret = DBexecute($sql)){
 			add_audit_ext(AUDIT_ACTION_DELETE, AUDIT_RESOURCE_MEDIA_TYPE, $mediatypeid, $mediatype['description'], NULL, NULL, NULL);
@@ -113,7 +113,7 @@
 		$sql='SELECT * '.
 			' FROM media_type '.
 			' WHERE description='.zbx_dbstr($description).
-				' AND mediatypeid<>'.$mediatypeid.
+				' AND mediatypeid<>'.zbx_dbstr($mediatypeid).
 				' AND '.DBin_node('mediatypeid');
 		$result=DBselect($sql);
 		if(DBfetch($result)){
@@ -132,7 +132,7 @@
 					'gsm_modem='.zbx_dbstr($gsm_modem).','.
 					'username='.zbx_dbstr($username).','.
 					'passwd='.zbx_dbstr($password).
-				' WHERE mediatypeid='.$mediatypeid;
+				' WHERE mediatypeid='.zbx_dbstr($mediatypeid);
 			$ret = DBexecute($sql);
 			if($ret){
 				$mediatype_new = get_mediatype_by_mediatypeid($mediatypeid);
@@ -200,7 +200,7 @@
 		$mediaid=get_dbid("media","mediaid");
 
 		$sql='INSERT INTO media (mediaid,userid,mediatypeid,sendto,active,severity,period) '.
-				" VALUES ($mediaid,$userid,".$mediatypeid.','.zbx_dbstr($sendto).','.$active.','.$s.','.zbx_dbstr($period).')';
+				" VALUES ($mediaid,".zbx_dbstr($userid).",".zbx_dbstr($mediatypeid).','.zbx_dbstr($sendto).','.zbx_dbstr($active).','.zbx_dbstr($s).','.zbx_dbstr($period).')';
 
 		if($ret = DBexecute($sql)){
 			$ret = $mediaid;
@@ -225,7 +225,7 @@
 		{
 			$s=$s|pow(2,(int)$severity[$i]);
 		}
-		$sql="update media set userid=$userid, mediatypeid=$mediatypeid, sendto=".zbx_dbstr($sendto).", active=$active,severity=$s,period=".zbx_dbstr($period)." where mediaid=$mediaid";
+		$sql="update media set userid=".zbx_dbstr($userid).", mediatypeid=".zbx_dbstr($mediatypeid).", sendto=".zbx_dbstr($sendto).", active=".zbx_dbstr($active).",severity=".zbx_dbstr($s).",period=".zbx_dbstr($period)." where mediaid=".zbx_dbstr($mediaid);
 		return	DBexecute($sql);
 	}
 
@@ -233,21 +233,21 @@
 
 	function	delete_media($mediaid)
 	{
-		return	DBexecute("delete from media where mediaid=$mediaid");
+		return	DBexecute("delete from media where mediaid=".zbx_dbstr($mediaid));
 	}
 
 	# Activate Media
 
 	function	activate_media($mediaid)
 	{
-		return	DBexecute("update media set active=0 where mediaid=$mediaid");
+		return	DBexecute("update media set active=0 where mediaid=".zbx_dbstr($mediaid));
 	}
 
 	# Disactivate Media
 
 	function	disactivate_media($mediaid)
 	{
-		return	DBexecute("update media set active=1 where mediaid=$mediaid");
+		return	DBexecute("update media set active=1 where mediaid=".zbx_dbstr($mediaid));
 	}
 
 ?>
Index: frontends/php/include/httptest.inc.php
===================================================================
--- frontends/php/include/httptest.inc.php	(revision 38884)
+++ frontends/php/include/httptest.inc.php	(working copy)
@@ -56,14 +56,14 @@
 			return false;
 		}
 
-		if(!$httpstep_data = DBfetch(DBselect('select httpstepid from httpstep where httptestid='.$httptestid.' and name='.zbx_dbstr($name)))){
+		if(!$httpstep_data = DBfetch(DBselect('select httpstepid from httpstep where httptestid='.zbx_dbstr($httptestid).' and name='.zbx_dbstr($name)))){
 
 			$httpstepid = get_dbid("httpstep","httpstepid");
 
 			if (!DBexecute('insert into httpstep'.
 				' (httpstepid, httptestid, name, no, url, timeout, posts, required, status_codes) '.
-				' values ('.$httpstepid.','.$httptestid.','.zbx_dbstr($name).','.$no.','.
-				zbx_dbstr($url).','.$timeout.','.
+				' values ('.$httpstepid.','.zbx_dbstr($httptestid).','.zbx_dbstr($name).','.zbx_dbstr($no).','.
+				zbx_dbstr($url).','.zbx_dbstr($timeout).','.
 				zbx_dbstr($posts).','.zbx_dbstr($required).','.zbx_dbstr($status_codes).')'
 				)) return false;
 		}
@@ -71,9 +71,9 @@
 			$httpstepid = $httpstep_data['httpstepid'];
 
 			if (!DBexecute('update httpstep set '.
-				' name='.zbx_dbstr($name).', no='.$no.', url='.zbx_dbstr($url).', timeout='.$timeout.','.
+				' name='.zbx_dbstr($name).', no='.zbx_dbstr($no).', url='.zbx_dbstr($url).', timeout='.zbx_dbstr($timeout).','.
 				' posts='.zbx_dbstr($posts).', required='.zbx_dbstr($required).', status_codes='.zbx_dbstr($status_codes).
-				' where httpstepid='.$httpstepid)) return false;
+				' where httpstepid='.zbx_dbstr($httpstepid))) return false;
 		}
 
 		$monitored_items = array(
@@ -100,12 +100,12 @@
 		foreach($monitored_items as $item){
 			$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.status,i.delta,i.valuemapid '.
 				' from items i, httpstepitem hi '.
-				' where hi.httpstepid='.$httpstepid.' and hi.itemid=i.itemid '.
-				' and hi.type='.$item['httpstepitemtype']));
+				' where hi.httpstepid='.zbx_dbstr($httpstepid).' and hi.itemid=i.itemid '.
+				' and hi.type='.zbx_dbstr($item['httpstepitemtype'])));
 
 			if(!$item_data){
 				$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.status,i.delta,i.valuemapid '.
-					' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.$hostid));
+					' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.zbx_dbstr($hostid)));
 			}
 
 			$item_args = array(
@@ -165,11 +165,11 @@
 
 			$httpstepitemid = get_dbid('httpstepitem', 'httpstepitemid');
 
-			DBexecute('delete from httpstepitem where itemid='.$itemid);
+			DBexecute('delete from httpstepitem where itemid='.zbx_dbstr($itemid));
 
 			if (!DBexecute('insert into httpstepitem'.
 				' (httpstepitemid, httpstepid, itemid, type) '.
-				' values ('.$httpstepitemid.','.$httpstepid.','.$itemid.','.$item['httpstepitemtype'].')'
+				' values ('.$httpstepitemid.','.zbx_dbstr($httpstepid).','.zbx_dbstr($itemid).','.zbx_dbstr($item['httpstepitemtype']).')'
 				)) return false;
 
 		}
@@ -193,7 +193,7 @@
 			$sql = 'SELECT t.httptestid'.
 					' FROM httptest t, applications a'.
 					' WHERE t.applicationid=a.applicationid'.
-						' AND a.hostid='.$hostid.
+						' AND a.hostid='.zbx_dbstr($hostid).
 						' AND t.name='.zbx_dbstr($name);
 			$t = DBfetch(DBselect($sql));
 			if((isset($httptestid) && $t && ($t['httptestid'] != $httptestid)) || ($t && !isset($httptestid))){
@@ -201,7 +201,7 @@
 			}
 			
 			
-			$sql = 'SELECT applicationid FROM applications WHERE name='.zbx_dbstr($application).' AND hostid='.$hostid;
+			$sql = 'SELECT applicationid FROM applications WHERE name='.zbx_dbstr($application).' AND hostid='.zbx_dbstr($hostid);
 			if($applicationid = DBfetch(DBselect($sql))){
 				$applicationid = $applicationid['applicationid'];
 			}
@@ -219,16 +219,16 @@
 				$sql = 'UPDATE httptest SET '.
 					' applicationid='.$applicationid.', '.
 					' name='.zbx_dbstr($name).', '.
-					' authentication='.$authentication.', '.
+					' authentication='.zbx_dbstr($authentication).', '.
 					' http_user='.zbx_dbstr($http_user).', '.
 					' http_password='.zbx_dbstr($http_password).', '.
-					' delay='.$delay.', '.
-					' status='.$status.', '.
+					' delay='.zbx_dbstr($delay).', '.
+					' status='.zbx_dbstr($status).', '.
 					' agent='.zbx_dbstr($agent).', '.
 					' macros='.zbx_dbstr($macros).', '.
 					' error='.zbx_dbstr('').', '.
 					' curstate='.HTTPTEST_STATE_UNKNOWN.
-				' WHERE httptestid='.$httptestid;
+				' WHERE httptestid='.zbx_dbstr($httptestid);
 				if(!DBexecute($sql)){
 					throw new Exception('DBerror');
 				}
@@ -240,11 +240,11 @@
 					'httptestid' => $httptestid,
 					'applicationid' => $applicationid,
 					'name' => zbx_dbstr($name),
-					'authentication' => $authentication,
+					'authentication' => zbx_dbstr($authentication),
 					'http_user' => zbx_dbstr($http_user),
 					'http_password' => zbx_dbstr($http_password),
-					'delay' => $delay,
-					'status' => $status,
+					'delay' => zbx_dbstr($delay),
+					'status' => zbx_dbstr($status),
 					'agent' => zbx_dbstr($agent),
 					'macros' => zbx_dbstr($macros),
 					'curstate' => HTTPTEST_STATE_UNKNOWN,
@@ -275,7 +275,7 @@
 			}
 			
 /* clean unneeded steps */
-			$sql = 'SELECT httpstepid FROM httpstep WHERE httptestid='.$httptestid;
+			$sql = 'SELECT httpstepid FROM httpstep WHERE httptestid='.zbx_dbstr($httptestid);
 			$db_steps = DBselect($sql);
 			while($step_data = DBfetch($db_steps)){
 				if(!isset($httpstepids[$step_data['httpstepid']])){
@@ -301,12 +301,12 @@
 			foreach($monitored_items as $item){
 				$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.status,i.delta,i.valuemapid '.
 					' from items i, httptestitem hi '.
-					' where hi.httptestid='.$httptestid.' and hi.itemid=i.itemid '.
-					' and hi.type='.$item['httptestitemtype']));
+					' where hi.httptestid='.zbx_dbstr($httptestid).' and hi.itemid=i.itemid '.
+					' and hi.type='.zbx_dbstr($item['httptestitemtype'])));
 
 				if(!$item_data){
 					$item_data = DBfetch(DBselect('select i.itemid,i.history,i.trends,i.status,i.delta,i.valuemapid '.
-						' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.$hostid));
+						' from items i where i.key_='.zbx_dbstr($item['key_']).' and i.hostid='.zbx_dbstr($hostid)));
 				}
 
 				$item_args = array(
@@ -366,10 +366,10 @@
 
 				$httptestitemid = get_dbid('httptestitem', 'httptestitemid');
 
-				DBexecute('delete from httptestitem where itemid='.$itemid);
+				DBexecute('delete from httptestitem where itemid='.zbx_dbstr($itemid));
 
 				if(!DBexecute('insert into httptestitem (httptestitemid, httptestid, itemid, type) '.
-					' values ('.$httptestitemid.','.$httptestid.','.$itemid.','.$item['httptestitemtype'].')')){
+					' values ('.$httptestitemid.','.zbx_dbstr($httptestid).','.zbx_dbstr($itemid).','.zbx_dbstr($item['httptestitemtype']).')')){
 					throw new Exception('DBerror');
 				}
 			}
@@ -403,7 +403,7 @@
 
 		$db_httpstepitems = DBselect('SELECT DISTINCT * FROM httpstepitem WHERE '.DBcondition('httpstepid',$httpstepids));
 		while($httpstepitem_data = DBfetch($db_httpstepitems)){
-			if(!DBexecute('DELETE FROM httpstepitem WHERE httpstepitemid='.$httpstepitem_data['httpstepitemid'])) return false;
+			if(!DBexecute('DELETE FROM httpstepitem WHERE httpstepitemid='.zbx_dbstr($httpstepitem_data['httpstepitemid']))) return false;
 			if(!delete_item($httpstepitem_data['itemid'])) return false;
 		}
 
@@ -415,7 +415,7 @@
 
 		$httptests = array();
 		foreach($httptestids as $id => $httptestid){
-			$httptests[$httptestid] =  DBfetch(DBselect('SELECT * FROM httptest WHERE httptestid='.$httptestid));
+			$httptests[$httptestid] =  DBfetch(DBselect('SELECT * FROM httptest WHERE httptestid='.zbx_dbstr($httptestid)));
 		}
 
 		$db_httpstep = DBselect('SELECT DISTINCT s.httpstepid '.
@@ -452,17 +452,17 @@
 	}
 
 	function activate_httptest($httptestid){
-		return DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_ACTIVE.' WHERE httptestid='.$httptestid);
+		return DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_ACTIVE.' WHERE httptestid='.zbx_dbstr($httptestid));
 	}
 
 	function disable_httptest($httptestid){
-		return DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_DISABLED.' WHERE httptestid='.$httptestid);
+		return DBexecute('UPDATE httptest SET status='.HTTPTEST_STATUS_DISABLED.' WHERE httptestid='.zbx_dbstr($httptestid));
 	}
 
 	function delete_history_by_httptestid($httptestid){
 		$db_items = DBselect('SELECT DISTINCT i.itemid '.
 							' FROM items i, httpstepitem si, httpstep s '.
-							' WHERE s.httptestid='.$httptestid.
+							' WHERE s.httptestid='.zbx_dbstr($httptestid).
 								' AND si.httpstepid=s.httpstepid '.
 								' AND i.itemid=si.itemid');
 		while($item_data = DBfetch($db_items)){
@@ -472,19 +472,19 @@
 	}
 
 	function get_httptest_by_httptestid($httptestid){
-		return DBfetch(DBselect('select * from httptest where httptestid='.$httptestid));
+		return DBfetch(DBselect('select * from httptest where httptestid='.zbx_dbstr($httptestid)));
 	}
 
 	function get_httpsteps_by_httptestid($httptestid){
-		return DBselect('select * from httpstep where httptestid='.$httptestid);
+		return DBselect('select * from httpstep where httptestid='.zbx_dbstr($httptestid));
 	}
 
 	function get_httpstep_by_httpstepid($httpstepid){
-		return DBfetch(DBselect('select * from httpstep where httpstepid='.$httpstepid));
+		return DBfetch(DBselect('select * from httpstep where httpstepid='.zbx_dbstr($httpstepid)));
 	}
 
 	function get_httpstep_by_no($httptestid, $no){
-		return DBfetch(DBselect('select * from httpstep where httptestid='.$httptestid.' and no='.$no));
+		return DBfetch(DBselect('select * from httpstep where httptestid='.zbx_dbstr($httptestid).' and no='.zbx_dbstr($no)));
 	}
 
 	function get_httptests_by_hostid($hostids){
